# innermost variable 'y' lies within:

# local(hard) scope
function f(x)
  y = x;
  x+y+1;
end
y = 1;
@show f(2), y
# >>
# (f(2), y) = (5, 1)


# local(hard) scope
function f(x)
  global y = x;
  x+y+1;
end
y = 1;
@show f(2), y
# >>
# (f(2), y) = (5, 2)


# local(soft) scope
function g()
  x = y = 0;
  for i=1:3
    x += 1;
    y = x;
  end
  @show y;
end
g();
# >>
# y = 3


# local(soft) scope
function g()
  x = y = 0;
  for i=1:3
    x += 1;
    local y = x;
  end
  @show y;
end
g();
#>>
# y = 0
