using Plots
using LinearAlgebra
using DelimitedFiles

function picard_condition(X,b)

n, d = size(X)

e = randn(n)
yexact = X*b
ynoise = yexact + e

u, s, v = svd(X; full = true)

cnoise = u'*ynoise
c1noise = cnoise[1:d]

cexact = u'*yexact
c1exact = cexact[1:d]

x = 1:d;

znoise = abs.(c1noise)./s
zexact = abs.(c1exact)./s

plot(x,log10.(znoise), label = ["with noise"])
plot!(x,log10.(zexact), label = ["without noise"])

end
